# Esercizio Fair scheduling

# DATI
param n1;
param n2;
set N1 := 1..n1;
set N2 := 1..n2;
param p1 {N1};
param p2 {N2};
set S := 1..n1+n2;

# VARIABILI
var x1 {N1,S} binary;
var x2 {N1,S} binary;
var c1 {N1};
var c2 {N2};
var delta;

# VINCOLI
s.t. Assign_position {j in S}: 
  sum {i in N1} x1[i,j] + sum {i in N2} x2[i,j] = 1;
s.t. Assign_job1 {i in N1}:
  sum {j in S} x1[i,j] = 1;
s.t. Assign_job2 {i in N2}:
  sum {j in S} x2[i,j] = 1;
  
s.t. Seq1 {i in N1,k in N1: (p1[i]<p1[k]) or ((p1[i]=p1[k]) and (i<k))}:
  sum {j in S} j * x1[i,j] <= sum {j in S} j * x1[k,j];
s.t. Seq2 {i in N2,k in N2: (p2[i]<p2[k]) or ((p2[i]=p2[k]) and (i<k))}:
  sum {j in S} j * x2[i,j] <= sum {j in S} j * x2[k,j];

s.t. CompletionTime1 {i in N1}:
  c1[i] = sum {j in S} x1[i,j] * 
  (sum {k in N1: (p1[k] < p1[i]) or ((p1[k]=p1[i]) and (k<=i))} p1[k] +
   sum {h in N2: card({k in N2: ((p2[k]<p2[h]) or ((p2[k]=p2[h]) and (k<=h)))}) <= 
                 j - card({k in N1: (p1[k] < p1[i]) or ((p1[k]=p1[i]) and (k<=i))}) } p2[h] );
s.t. CompletionTime2 {i in N2}:
  c2[i] = sum {j in S} x2[i,j] * 
  (sum {k in N2: (p2[k] < p2[i]) or ((p2[k]=p2[i]) and (k<=i))} p2[k] +
   sum {h in N1: card({k in N1: ((p1[k]<p1[h]) or ((p1[k]=p1[h]) and (k<=h)))}) <= 
                 j - card({k in N2: (p2[k] < p2[i]) or ((p2[k]=p2[i]) and (k<=i))}) } p1[h] );

# OBIETTIVO
minimize z: delta;
s.t. Minmax1: delta >= 
     sum {i in N1} ( c1[i] - sum {k in N1: (p1[k] < p1[i]) or ((p1[k]=p1[i]) and (k<=i))} p1[k] );
s.t. Minmax2: delta >= 
     sum {i in N2} ( c2[i] - sum {k in N2: (p2[k] < p2[i]) or ((p2[k]=p2[i]) and (k<=i))} p2[k] );

#######################
data;

param n1 :=  5;
param n2 :=  5;

param:  p1  p2 :=
1		25	15 
2		25	23 
3		21	22 
4		14	16 
5		18	23;

end;
